/* Indicator.c generated by valac 0.56.13, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
 * Copyright (c) 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "session.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <granite.h>
#include <gmodule.h>

#define SESSION_INDICATOR_ICON_NAME "system-shutdown-symbolic"
#define SESSION_INDICATOR_KEYBINDING_SCHEMA "org.gnome.settings-daemon.plugins.media-keys"
#define SESSION_GETTEXT_PACKAGE "session-indicator"
#define SESSION_LOCALEDIR "/usr/share/locale"

#define TYPE_LOCK_INTERFACE (lock_interface_get_type ())
#define LOCK_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCK_INTERFACE, LockInterface))
#define IS_LOCK_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCK_INTERFACE))
#define LOCK_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOCK_INTERFACE, LockInterfaceIface))

typedef struct _LockInterface LockInterface;
typedef struct _LockInterfaceIface LockInterfaceIface;

#define TYPE_LOCK_INTERFACE_PROXY (lock_interface_proxy_get_type ())

#define TYPE_SESSION_INTERFACE (session_interface_get_type ())
#define SESSION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SESSION_INTERFACE, SessionInterface))
#define IS_SESSION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SESSION_INTERFACE))
#define SESSION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SESSION_INTERFACE, SessionInterfaceIface))

typedef struct _SessionInterface SessionInterface;
typedef struct _SessionInterfaceIface SessionInterfaceIface;

#define TYPE_SESSION_INTERFACE_PROXY (session_interface_proxy_get_type ())

#define TYPE_SYSTEM_INTERFACE (system_interface_get_type ())
#define SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_INTERFACE, SystemInterface))
#define IS_SYSTEM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_INTERFACE))
#define SYSTEM_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SYSTEM_INTERFACE, SystemInterfaceIface))

typedef struct _SystemInterface SystemInterface;
typedef struct _SystemInterfaceIface SystemInterfaceIface;

#define TYPE_SYSTEM_INTERFACE_PROXY (system_interface_proxy_get_type ())

#define TYPE_USER_INFO (user_info_get_type ())
typedef struct _UserInfo UserInfo;
enum  {
	SESSION_INDICATOR_0_PROPERTY,
	SESSION_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* session_indicator_properties[SESSION_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SessionIndicatorInitInterfacesData SessionIndicatorInitInterfacesData;
typedef struct _Block2Data Block2Data;
typedef struct _SessionIndicatorUpdateTooltipData SessionIndicatorUpdateTooltipData;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

struct _LockInterfaceIface {
	GTypeInterface parent_iface;
	void (*lock) (LockInterface* self, GError** error);
};

struct _SessionInterfaceIface {
	GTypeInterface parent_iface;
	void (*logout) (SessionInterface* self, guint type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*logout_finish) (SessionInterface* self, GAsyncResult* _res_, GError** error);
	void (*reboot) (SessionInterface* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*reboot_finish) (SessionInterface* self, GAsyncResult* _res_, GError** error);
	void (*shutdown) (SessionInterface* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*shutdown_finish) (SessionInterface* self, GAsyncResult* _res_, GError** error);
};

struct _UserInfo {
	guint32 uid;
	gchar* user_name;
	char* user_object;
};

struct _SystemInterfaceIface {
	GTypeInterface parent_iface;
	void (*suspend) (SystemInterface* self, gboolean interactive, GError** error);
	void (*reboot) (SystemInterface* self, gboolean interactive, GError** error);
	void (*power_off) (SystemInterface* self, gboolean interactive, GError** error);
	UserInfo* (*list_users) (SystemInterface* self, gint* result_length1, GError** error);
};

struct _SessionIndicatorPrivate {
	LockInterface* lock_interface;
	SessionInterface* session_interface;
	SystemInterface* system_interface;
	WingpanelIndicatorManagerServerType server_type;
	GtkImage* indicator_icon;
	GtkModelButton* lock_screen;
	GtkModelButton* suspend;
	GtkModelButton* shutdown;
	GtkModelButton* log_out;
	SessionServicesUserManager* manager;
	SessionWidgetsEndSessionDialog* current_dialog;
	GtkBox* main_box;
	gchar* active_user_real_name;
};

struct _Block1Data {
	int _ref_count_;
	SessionIndicator* self;
	GraniteAccelLabel* log_out_grid;
	GraniteAccelLabel* lock_screen_grid;
};

struct _SessionIndicatorInitInterfacesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SessionIndicator* self;
	SystemInterface* _tmp0_;
	SystemInterface* _tmp1_;
	SystemInterface* _tmp2_;
	GtkModelButton* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GtkModelButton* _tmp6_;
	LockInterface* _tmp7_;
	LockInterface* _tmp8_;
	LockInterface* _tmp9_;
	GtkModelButton* _tmp10_;
	GError* _vala1_e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	SessionInterface* _tmp13_;
	SessionInterface* _tmp14_;
	SessionInterface* _tmp15_;
	GtkModelButton* _tmp16_;
	GtkModelButton* _tmp17_;
	GError* _vala2_e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	SessionIndicator* self;
	SessionEndSessionDialogServer* server;
};

struct _SessionIndicatorUpdateTooltipData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SessionIndicator* self;
	gchar* description;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gint n_online_users;
	SessionServicesUserManager* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* accel_label;
	gchar* _tmp11_;
	GtkImage* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
};

static gint SessionIndicator_private_offset;
static gpointer session_indicator_parent_class = NULL;
static GSettings* session_indicator_keybinding_settings;
static GSettings* session_indicator_keybinding_settings = NULL;

VALA_EXTERN GType lock_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint lock_interface_register_object (void* object,
                                      GDBusConnection* connection,
                                      const gchar* path,
                                      GError** error);
VALA_EXTERN GType lock_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType session_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint session_interface_register_object (void* object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error);
VALA_EXTERN GType session_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType system_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint system_interface_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
VALA_EXTERN GType user_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserInfo* user_info_dup (const UserInfo* self);
VALA_EXTERN void user_info_free (UserInfo* self);
VALA_EXTERN void user_info_copy (const UserInfo* self,
                     UserInfo* dest);
VALA_EXTERN void user_info_destroy (UserInfo* self);
VALA_EXTERN GType system_interface_get_type (void) G_GNUC_CONST ;
static void __lambda17_ (SessionIndicator* self,
                  guint type);
static void session_indicator_show_dialog (SessionIndicator* self,
                                    SessionWidgetsEndSessionDialogType type);
static void ___lambda17__session_end_session_dialog_server_show_dialog (SessionEndSessionDialogServer* _sender,
                                                                 guint type,
                                                                 gpointer self);
static GtkWidget* session_indicator_real_get_display_widget (WingpanelIndicator* base);
static void ___lambda23_ (SessionIndicator* self);
static void session_indicator_update_tooltip (SessionIndicator* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void session_indicator_update_tooltip_finish (SessionIndicator* self,
                                              GAsyncResult* _res_);
static void ____lambda23__session_services_user_manager_changed (SessionServicesUserManager* _sender,
                                                          gpointer self);
static gboolean ___lambda24_ (SessionIndicator* self,
                       GdkEventButton* e);
static void session_indicator_init_interfaces (SessionIndicator* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void session_indicator_init_interfaces_finish (SessionIndicator* self,
                                               GAsyncResult* _res_);
static void ____lambda25_ (SessionIndicator* self,
                    GObject* obj,
                    GAsyncResult* res);
static void session_indicator_show_shutdown_dialog (SessionIndicator* self);
static void _____lambda25__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static gboolean ____lambda24__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static GtkWidget* session_indicator_real_get_widget (WingpanelIndicator* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _____lambda27_ (Block1Data* _data1_);
static void ______lambda27__g_settings_changed (GSettings* _sender,
                                         const gchar* key,
                                         gpointer self);
static void _____lambda28_ (Block1Data* _data1_);
static void ______lambda28__g_settings_changed (GSettings* _sender,
                                         const gchar* key,
                                         gpointer self);
static void ______lambda29_ (Block1Data* _data1_);
static void _______lambda29__g_settings_changed (GSettings* _sender,
                                          const gchar* key,
                                          gpointer self);
static void ______lambda30_ (Block1Data* _data1_);
static void _______lambda30__g_settings_changed (GSettings* _sender,
                                          const gchar* key,
                                          gpointer self);
static void ___lambda31_ (SessionIndicator* self);
static void ____lambda31__session_services_user_manager_close (SessionServicesUserManager* _sender,
                                                        gpointer self);
static void ___lambda32_ (SessionIndicator* self);
static void ____lambda32__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda33_ (SessionIndicator* self);
static void ____lambda33__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda34_ (SessionIndicator* self);
VALA_EXTERN void system_interface_suspend (SystemInterface* self,
                               gboolean interactive,
                               GError** error);
static void ____lambda34__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda35_ (SessionIndicator* self);
VALA_EXTERN void session_interface_logout (SessionInterface* self,
                               guint type,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN void session_interface_logout_finish (SessionInterface* self,
                                      GAsyncResult* _res_,
                                      GError** error);
static void __lambda36_ (SessionIndicator* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda36__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ____lambda35__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda37_ (SessionIndicator* self);
VALA_EXTERN void lock_interface_lock (LockInterface* self,
                          GError** error);
static void ____lambda37__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
VALA_EXTERN void session_interface_reboot (SessionInterface* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN void session_interface_reboot_finish (SessionInterface* self,
                                      GAsyncResult* _res_,
                                      GError** error);
static void ___lambda26_ (SessionIndicator* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda26__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void session_indicator_init_interfaces_data_free (gpointer _data);
static gboolean session_indicator_init_interfaces_co (SessionIndicatorInitInterfacesData* _data_);
static void session_indicator_init_interfaces_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void session_indicator_real_opened (WingpanelIndicator* base);
static void session_indicator_real_closed (WingpanelIndicator* base);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda18_ (Block2Data* _data2_);
static void ___lambda18__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static void __lambda19_ (Block2Data* _data2_);
static void ___lambda19__session_widgets_end_session_dialog_cancelled (SessionWidgetsEndSessionDialog* _sender,
                                                                gpointer self);
static void __lambda20_ (Block2Data* _data2_);
static void ___lambda20__session_widgets_end_session_dialog_logout (SessionWidgetsEndSessionDialog* _sender,
                                                             gpointer self);
static void __lambda21_ (Block2Data* _data2_);
VALA_EXTERN void system_interface_power_off (SystemInterface* self,
                                 gboolean interactive,
                                 GError** error);
static void ___lambda21__session_widgets_end_session_dialog_shutdown (SessionWidgetsEndSessionDialog* _sender,
                                                               gpointer self);
static void __lambda22_ (Block2Data* _data2_);
VALA_EXTERN void system_interface_reboot (SystemInterface* self,
                              gboolean interactive,
                              GError** error);
static void ___lambda22__session_widgets_end_session_dialog_reboot (SessionWidgetsEndSessionDialog* _sender,
                                                             gpointer self);
static void session_indicator_update_tooltip_data_free (gpointer _data);
static gboolean session_indicator_update_tooltip_co (SessionIndicatorUpdateTooltipData* _data_);
static void session_indicator_update_tooltip_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void session_indicator_finalize (GObject * obj);
static GType session_indicator_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
session_indicator_get_instance_private (SessionIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SessionIndicator_private_offset);
}

static void
__lambda17_ (SessionIndicator* self,
             guint type)
{
#line 53 "../src/Indicator.vala"
	session_indicator_show_dialog (self, (SessionWidgetsEndSessionDialogType) type);
#line 392 "Indicator.c"
}

static void
___lambda17__session_end_session_dialog_server_show_dialog (SessionEndSessionDialogServer* _sender,
                                                            guint type,
                                                            gpointer self)
{
#line 53 "../src/Indicator.vala"
	__lambda17_ ((SessionIndicator*) self, type);
#line 402 "Indicator.c"
}

SessionIndicator*
session_indicator_construct (GType object_type,
                             WingpanelIndicatorManagerServerType server_type)
{
	SessionIndicator * self = NULL;
	SessionEndSessionDialogServer* _tmp0_;
	SessionServicesUserManager* _tmp1_;
#line 45 "../src/Indicator.vala"
	bindtextdomain (SESSION_GETTEXT_PACKAGE, SESSION_LOCALEDIR);
#line 46 "../src/Indicator.vala"
	bind_textdomain_codeset (SESSION_GETTEXT_PACKAGE, "UTF-8");
#line 48 "../src/Indicator.vala"
	self = (SessionIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_SESSION, NULL);
#line 49 "../src/Indicator.vala"
	self->priv->server_type = server_type;
#line 50 "../src/Indicator.vala"
	wingpanel_indicator_set_visible ((WingpanelIndicator*) self, TRUE);
#line 52 "../src/Indicator.vala"
	session_end_session_dialog_server_init ();
#line 53 "../src/Indicator.vala"
	_tmp0_ = session_end_session_dialog_server_get_default ();
#line 53 "../src/Indicator.vala"
	g_signal_connect_object (_tmp0_, "show-dialog", (GCallback) ___lambda17__session_end_session_dialog_server_show_dialog, self, 0);
#line 55 "../src/Indicator.vala"
	_tmp1_ = session_services_user_manager_new ();
#line 55 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->manager);
#line 55 "../src/Indicator.vala"
	self->priv->manager = _tmp1_;
#line 44 "../src/Indicator.vala"
	return self;
#line 436 "Indicator.c"
}

SessionIndicator*
session_indicator_new (WingpanelIndicatorManagerServerType server_type)
{
#line 44 "../src/Indicator.vala"
	return session_indicator_construct (SESSION_TYPE_INDICATOR, server_type);
#line 444 "Indicator.c"
}

static void
___lambda23_ (SessionIndicator* self)
{
#line 72 "../src/Indicator.vala"
	session_indicator_update_tooltip (self, NULL, NULL);
#line 452 "Indicator.c"
}

static void
____lambda23__session_services_user_manager_changed (SessionServicesUserManager* _sender,
                                                     gpointer self)
{
#line 71 "../src/Indicator.vala"
	___lambda23_ ((SessionIndicator*) self);
#line 461 "Indicator.c"
}

static void
____lambda25_ (SessionIndicator* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 78 "../src/Indicator.vala"
	g_return_if_fail (res != NULL);
#line 79 "../src/Indicator.vala"
	session_indicator_init_interfaces_finish (self, res);
#line 80 "../src/Indicator.vala"
	session_indicator_show_shutdown_dialog (self);
#line 475 "Indicator.c"
}

static void
_____lambda25__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 78 "../src/Indicator.vala"
	____lambda25_ ((SessionIndicator*) self, source_object, res);
#line 78 "../src/Indicator.vala"
	g_object_unref (self);
#line 487 "Indicator.c"
}

static gboolean
___lambda24_ (SessionIndicator* self,
              GdkEventButton* e)
{
	gboolean result;
#line 75 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 76 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 499 "Indicator.c"
		SessionInterface* _tmp0_;
#line 77 "../src/Indicator.vala"
		_tmp0_ = self->priv->session_interface;
#line 77 "../src/Indicator.vala"
		if (_tmp0_ == NULL) {
#line 78 "../src/Indicator.vala"
			session_indicator_init_interfaces (self, _____lambda25__gasync_ready_callback, g_object_ref (self));
#line 507 "Indicator.c"
		} else {
#line 83 "../src/Indicator.vala"
			session_indicator_show_shutdown_dialog (self);
#line 511 "Indicator.c"
		}
#line 86 "../src/Indicator.vala"
		result = GDK_EVENT_STOP;
#line 86 "../src/Indicator.vala"
		return result;
#line 517 "Indicator.c"
	}
#line 89 "../src/Indicator.vala"
	result = GDK_EVENT_PROPAGATE;
#line 89 "../src/Indicator.vala"
	return result;
#line 523 "Indicator.c"
}

static gboolean
____lambda24__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda24_ ((SessionIndicator*) self, event);
#line 75 "../src/Indicator.vala"
	return result;
#line 535 "Indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 93 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 543 "Indicator.c"
}

static GtkWidget*
session_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	SessionIndicator * self;
	GtkImage* _tmp0_;
	GtkImage* _tmp5_;
	GtkWidget* _tmp6_;
	GtkWidget* result;
#line 64 "../src/Indicator.vala"
	self = (SessionIndicator*) base;
#line 65 "../src/Indicator.vala"
	_tmp0_ = self->priv->indicator_icon;
#line 65 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 560 "Indicator.c"
		gchar* _tmp1_;
		GtkImage* _tmp2_ = NULL;
		SessionServicesUserManager* _tmp3_;
		GtkImage* _tmp4_;
#line 66 "../src/Indicator.vala"
		_tmp1_ = g_strdup (SESSION_INDICATOR_ICON_NAME);
#line 66 "../src/Indicator.vala"
		_tmp2_ = (GtkImage*) gtk_image_new ();
#line 66 "../src/Indicator.vala"
		g_object_set (_tmp2_, "icon-name", _tmp1_, NULL);
#line 66 "../src/Indicator.vala"
		_g_free0 (_tmp1_);
#line 66 "../src/Indicator.vala"
		gtk_image_set_pixel_size (_tmp2_, 24);
#line 66 "../src/Indicator.vala"
		g_object_ref_sink (_tmp2_);
#line 66 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->indicator_icon);
#line 66 "../src/Indicator.vala"
		self->priv->indicator_icon = _tmp2_;
#line 71 "../src/Indicator.vala"
		_tmp3_ = self->priv->manager;
#line 71 "../src/Indicator.vala"
		g_signal_connect_object (_tmp3_, "changed", (GCallback) ____lambda23__session_services_user_manager_changed, self, 0);
#line 75 "../src/Indicator.vala"
		_tmp4_ = self->priv->indicator_icon;
#line 75 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "button-press-event", (GCallback) ____lambda24__gtk_widget_button_press_event, self, 0);
#line 589 "Indicator.c"
	}
#line 93 "../src/Indicator.vala"
	_tmp5_ = self->priv->indicator_icon;
#line 93 "../src/Indicator.vala"
	_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
#line 93 "../src/Indicator.vala"
	result = _tmp6_;
#line 93 "../src/Indicator.vala"
	return result;
#line 599 "Indicator.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 97 "../src/Indicator.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 97 "../src/Indicator.vala"
	return _data1_;
#line 609 "Indicator.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 97 "../src/Indicator.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 619 "Indicator.c"
		SessionIndicator* self;
#line 97 "../src/Indicator.vala"
		self = _data1_->self;
#line 97 "../src/Indicator.vala"
		_g_object_unref0 (_data1_->lock_screen_grid);
#line 97 "../src/Indicator.vala"
		_g_object_unref0 (_data1_->log_out_grid);
#line 97 "../src/Indicator.vala"
		_g_object_unref0 (self);
#line 97 "../src/Indicator.vala"
		g_slice_free (Block1Data, _data1_);
#line 631 "Indicator.c"
	}
}

static void
_____lambda27_ (Block1Data* _data1_)
{
	SessionIndicator* self;
	GraniteAccelLabel* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 171 "../src/Indicator.vala"
	self = _data1_->self;
#line 172 "../src/Indicator.vala"
	_tmp0_ = _data1_->log_out_grid;
#line 172 "../src/Indicator.vala"
	_tmp1_ = session_indicator_keybinding_settings;
#line 172 "../src/Indicator.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "logout");
#line 172 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/Indicator.vala"
	granite_accel_label_set_accel_string (_tmp0_, _tmp3_);
#line 172 "../src/Indicator.vala"
	_g_free0 (_tmp3_);
#line 657 "Indicator.c"
}

static void
______lambda27__g_settings_changed (GSettings* _sender,
                                    const gchar* key,
                                    gpointer self)
{
#line 171 "../src/Indicator.vala"
	_____lambda27_ (self);
#line 667 "Indicator.c"
}

static void
_____lambda28_ (Block1Data* _data1_)
{
	SessionIndicator* self;
	GraniteAccelLabel* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 175 "../src/Indicator.vala"
	self = _data1_->self;
#line 176 "../src/Indicator.vala"
	_tmp0_ = _data1_->lock_screen_grid;
#line 176 "../src/Indicator.vala"
	_tmp1_ = session_indicator_keybinding_settings;
#line 176 "../src/Indicator.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "screensaver");
#line 176 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 176 "../src/Indicator.vala"
	granite_accel_label_set_accel_string (_tmp0_, _tmp3_);
#line 176 "../src/Indicator.vala"
	_g_free0 (_tmp3_);
#line 692 "Indicator.c"
}

static void
______lambda28__g_settings_changed (GSettings* _sender,
                                    const gchar* key,
                                    gpointer self)
{
#line 175 "../src/Indicator.vala"
	_____lambda28_ (self);
#line 702 "Indicator.c"
}

static void
______lambda29_ (Block1Data* _data1_)
{
	SessionIndicator* self;
	GraniteAccelLabel* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
#line 182 "../src/Indicator.vala"
	self = _data1_->self;
#line 183 "../src/Indicator.vala"
	_tmp0_ = _data1_->log_out_grid;
#line 183 "../src/Indicator.vala"
	_tmp1_ = session_indicator_keybinding_settings;
#line 183 "../src/Indicator.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "logout");
#line 183 "../src/Indicator.vala"
	_tmp4_ = _tmp3_;
#line 183 "../src/Indicator.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 183 "../src/Indicator.vala"
	_tmp5_ = _tmp4_[0];
#line 183 "../src/Indicator.vala"
	granite_accel_label_set_accel_string (_tmp0_, _tmp5_);
#line 183 "../src/Indicator.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 734 "Indicator.c"
}

static void
_______lambda29__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self)
{
#line 182 "../src/Indicator.vala"
	______lambda29_ (self);
#line 744 "Indicator.c"
}

static void
______lambda30_ (Block1Data* _data1_)
{
	SessionIndicator* self;
	GraniteAccelLabel* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
#line 186 "../src/Indicator.vala"
	self = _data1_->self;
#line 187 "../src/Indicator.vala"
	_tmp0_ = _data1_->lock_screen_grid;
#line 187 "../src/Indicator.vala"
	_tmp1_ = session_indicator_keybinding_settings;
#line 187 "../src/Indicator.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "screensaver");
#line 187 "../src/Indicator.vala"
	_tmp4_ = _tmp3_;
#line 187 "../src/Indicator.vala"
	_tmp4__length1 = _vala_array_length (_tmp2_);
#line 187 "../src/Indicator.vala"
	_tmp5_ = _tmp4_[0];
#line 187 "../src/Indicator.vala"
	granite_accel_label_set_accel_string (_tmp0_, _tmp5_);
#line 187 "../src/Indicator.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 776 "Indicator.c"
}

static void
_______lambda30__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self)
{
#line 186 "../src/Indicator.vala"
	______lambda30_ (self);
#line 786 "Indicator.c"
}

static void
___lambda31_ (SessionIndicator* self)
{
#line 192 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 794 "Indicator.c"
}

static void
____lambda31__session_services_user_manager_close (SessionServicesUserManager* _sender,
                                                   gpointer self)
{
#line 192 "../src/Indicator.vala"
	___lambda31_ ((SessionIndicator*) self);
#line 803 "Indicator.c"
}

static void
___lambda32_ (SessionIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 195 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 812 "Indicator.c"
	{
#line 198 "../src/Indicator.vala"
		g_app_info_launch_default_for_uri ("settings://accounts", NULL, &_inner_error0_);
#line 198 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 818 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 197 "../src/Indicator.vala"
		e = _inner_error0_;
#line 197 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 200 "../src/Indicator.vala"
		_tmp0_ = e;
#line 200 "../src/Indicator.vala"
		_tmp1_ = _tmp0_->message;
#line 200 "../src/Indicator.vala"
		g_warning ("Indicator.vala:200: Failed to open user accounts settings: %s", _tmp1_);
#line 197 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 840 "Indicator.c"
	}
	__finally0:
#line 197 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 197 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 197 "../src/Indicator.vala"
		return;
#line 851 "Indicator.c"
	}
}

static void
____lambda32__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 194 "../src/Indicator.vala"
	___lambda32_ ((SessionIndicator*) self);
#line 861 "Indicator.c"
}

static void
___lambda33_ (SessionIndicator* self)
{
#line 205 "../src/Indicator.vala"
	session_indicator_show_shutdown_dialog (self);
#line 869 "Indicator.c"
}

static void
____lambda33__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 204 "../src/Indicator.vala"
	___lambda33_ ((SessionIndicator*) self);
#line 878 "Indicator.c"
}

static void
___lambda34_ (SessionIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 209 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 887 "Indicator.c"
	{
		SystemInterface* _tmp0_;
#line 212 "../src/Indicator.vala"
		_tmp0_ = self->priv->system_interface;
#line 212 "../src/Indicator.vala"
		system_interface_suspend (_tmp0_, TRUE, &_inner_error0_);
#line 212 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 896 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 211 "../src/Indicator.vala"
		e = _inner_error0_;
#line 211 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 214 "../src/Indicator.vala"
		_tmp1_ = e;
#line 214 "../src/Indicator.vala"
		_tmp2_ = _tmp1_->message;
#line 214 "../src/Indicator.vala"
		g_warning ("Indicator.vala:214: Unable to suspend: %s", _tmp2_);
#line 211 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 918 "Indicator.c"
	}
	__finally0:
#line 211 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 211 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 211 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 211 "../src/Indicator.vala"
		return;
#line 929 "Indicator.c"
	}
}

static void
____lambda34__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 208 "../src/Indicator.vala"
	___lambda34_ ((SessionIndicator*) self);
#line 939 "Indicator.c"
}

static void
__lambda36_ (SessionIndicator* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 219 "../src/Indicator.vala"
	g_return_if_fail (res != NULL);
#line 950 "Indicator.c"
	{
		SessionInterface* _tmp0_;
#line 221 "../src/Indicator.vala"
		_tmp0_ = self->priv->session_interface;
#line 221 "../src/Indicator.vala"
		session_interface_logout_finish (_tmp0_, res, &_inner_error0_);
#line 221 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 959 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
#line 220 "../src/Indicator.vala"
		e = _inner_error0_;
#line 220 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 223 "../src/Indicator.vala"
		_tmp1_ = e;
#line 223 "../src/Indicator.vala"
		if (!g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 976 "Indicator.c"
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 224 "../src/Indicator.vala"
			_tmp2_ = e;
#line 224 "../src/Indicator.vala"
			_tmp3_ = _tmp2_->message;
#line 224 "../src/Indicator.vala"
			g_warning ("Indicator.vala:224: Unable to open logout dialog: %s", _tmp3_);
#line 985 "Indicator.c"
		}
#line 220 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 989 "Indicator.c"
	}
	__finally0:
#line 220 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 220 "../src/Indicator.vala"
		return;
#line 1000 "Indicator.c"
	}
}

static void
___lambda36__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 219 "../src/Indicator.vala"
	__lambda36_ ((SessionIndicator*) self, source_object, res);
#line 219 "../src/Indicator.vala"
	g_object_unref (self);
#line 1013 "Indicator.c"
}

static void
___lambda35_ (SessionIndicator* self)
{
	SessionInterface* _tmp0_;
#line 219 "../src/Indicator.vala"
	_tmp0_ = self->priv->session_interface;
#line 219 "../src/Indicator.vala"
	session_interface_logout (_tmp0_, (guint) 0, ___lambda36__gasync_ready_callback, g_object_ref (self));
#line 1024 "Indicator.c"
}

static void
____lambda35__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 218 "../src/Indicator.vala"
	___lambda35_ ((SessionIndicator*) self);
#line 1033 "Indicator.c"
}

static void
___lambda37_ (SessionIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 231 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 1042 "Indicator.c"
	{
		LockInterface* _tmp0_;
#line 234 "../src/Indicator.vala"
		_tmp0_ = self->priv->lock_interface;
#line 234 "../src/Indicator.vala"
		lock_interface_lock (_tmp0_, &_inner_error0_);
#line 234 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1051 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 233 "../src/Indicator.vala"
		e = _inner_error0_;
#line 233 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 236 "../src/Indicator.vala"
		_tmp1_ = e;
#line 236 "../src/Indicator.vala"
		_tmp2_ = _tmp1_->message;
#line 236 "../src/Indicator.vala"
		g_warning ("Indicator.vala:236: Unable to lock: %s", _tmp2_);
#line 233 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 1073 "Indicator.c"
	}
	__finally0:
#line 233 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 233 "../src/Indicator.vala"
		return;
#line 1084 "Indicator.c"
	}
}

static void
____lambda37__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 230 "../src/Indicator.vala"
	___lambda37_ ((SessionIndicator*) self);
#line 1094 "Indicator.c"
}

static GtkWidget*
session_indicator_real_get_widget (WingpanelIndicator* base)
{
	SessionIndicator * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp83_;
	GtkWidget* _tmp84_;
	GtkWidget* result;
#line 96 "../src/Indicator.vala"
	self = (SessionIndicator*) base;
#line 97 "../src/Indicator.vala"
	_tmp0_ = self->priv->main_box;
#line 97 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 1111 "Indicator.c"
		Block1Data* _data1_;
		GtkBox* _tmp1_;
		GtkModelButton* user_settings = NULL;
		gchar* _tmp2_;
		GtkModelButton* _tmp3_ = NULL;
		GraniteAccelLabel* _tmp4_;
		GtkModelButton* _tmp5_ = NULL;
		GtkModelButton* _tmp6_;
		GtkWidget* _tmp7_;
		GtkModelButton* _tmp8_;
		GraniteAccelLabel* _tmp9_;
		GraniteAccelLabel* _tmp10_;
		GtkModelButton* _tmp11_ = NULL;
		GtkModelButton* _tmp12_;
		GtkWidget* _tmp13_;
		GtkModelButton* _tmp14_;
		GraniteAccelLabel* _tmp15_;
		gchar* _tmp16_;
		GtkModelButton* _tmp17_ = NULL;
		gchar* _tmp18_;
		GtkModelButton* _tmp19_ = NULL;
		GtkBox* _tmp39_;
		GtkModelButton* _tmp40_;
		GtkBox* _tmp41_;
		GtkModelButton* _tmp42_;
		GSettings* _tmp43_;
		SessionServicesUserManager* _tmp77_;
		GtkModelButton* _tmp78_;
		GtkModelButton* _tmp79_;
		GtkModelButton* _tmp80_;
		GtkModelButton* _tmp81_;
		GtkModelButton* _tmp82_;
#line 97 "../src/Indicator.vala"
		_data1_ = g_slice_new0 (Block1Data);
#line 97 "../src/Indicator.vala"
		_data1_->_ref_count_ = 1;
#line 97 "../src/Indicator.vala"
		_data1_->self = g_object_ref (self);
#line 98 "../src/Indicator.vala"
		session_indicator_init_interfaces (self, NULL, NULL);
#line 100 "../src/Indicator.vala"
		_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 100 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 100 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->main_box);
#line 100 "../src/Indicator.vala"
		self->priv->main_box = _tmp1_;
#line 102 "../src/Indicator.vala"
		_tmp2_ = g_strdup (_ ("User Accounts Settings…"));
#line 102 "../src/Indicator.vala"
		_tmp3_ = (GtkModelButton*) gtk_model_button_new ();
#line 102 "../src/Indicator.vala"
		g_object_set (_tmp3_, "text", _tmp2_, NULL);
#line 102 "../src/Indicator.vala"
		_g_free0 (_tmp2_);
#line 102 "../src/Indicator.vala"
		g_object_ref_sink (_tmp3_);
#line 102 "../src/Indicator.vala"
		user_settings = _tmp3_;
#line 106 "../src/Indicator.vala"
		_tmp4_ = granite_accel_label_new (_ ("Log Out…"), NULL);
#line 106 "../src/Indicator.vala"
		g_object_ref_sink (_tmp4_);
#line 106 "../src/Indicator.vala"
		_data1_->log_out_grid = _tmp4_;
#line 108 "../src/Indicator.vala"
		_tmp5_ = (GtkModelButton*) gtk_model_button_new ();
#line 108 "../src/Indicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 108 "../src/Indicator.vala"
		g_object_ref_sink (_tmp5_);
#line 108 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->log_out);
#line 108 "../src/Indicator.vala"
		self->priv->log_out = _tmp5_;
#line 112 "../src/Indicator.vala"
		_tmp6_ = self->priv->log_out;
#line 112 "../src/Indicator.vala"
		_tmp7_ = gtk_bin_get_child ((GtkBin*) _tmp6_);
#line 112 "../src/Indicator.vala"
		gtk_widget_destroy (_tmp7_);
#line 113 "../src/Indicator.vala"
		_tmp8_ = self->priv->log_out;
#line 113 "../src/Indicator.vala"
		_tmp9_ = _data1_->log_out_grid;
#line 113 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 115 "../src/Indicator.vala"
		_tmp10_ = granite_accel_label_new (_ ("Lock"), NULL);
#line 115 "../src/Indicator.vala"
		g_object_ref_sink (_tmp10_);
#line 115 "../src/Indicator.vala"
		_data1_->lock_screen_grid = _tmp10_;
#line 117 "../src/Indicator.vala"
		_tmp11_ = (GtkModelButton*) gtk_model_button_new ();
#line 117 "../src/Indicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 117 "../src/Indicator.vala"
		g_object_ref_sink (_tmp11_);
#line 117 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->lock_screen);
#line 117 "../src/Indicator.vala"
		self->priv->lock_screen = _tmp11_;
#line 121 "../src/Indicator.vala"
		_tmp12_ = self->priv->lock_screen;
#line 121 "../src/Indicator.vala"
		_tmp13_ = gtk_bin_get_child ((GtkBin*) _tmp12_);
#line 121 "../src/Indicator.vala"
		gtk_widget_destroy (_tmp13_);
#line 122 "../src/Indicator.vala"
		_tmp14_ = self->priv->lock_screen;
#line 122 "../src/Indicator.vala"
		_tmp15_ = _data1_->lock_screen_grid;
#line 122 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 124 "../src/Indicator.vala"
		_tmp16_ = g_strdup (_ ("Shut Down…"));
#line 124 "../src/Indicator.vala"
		_tmp17_ = (GtkModelButton*) gtk_model_button_new ();
#line 124 "../src/Indicator.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
#line 124 "../src/Indicator.vala"
		g_object_set (_tmp17_, "text", _tmp16_, NULL);
#line 124 "../src/Indicator.vala"
		_g_free0 (_tmp16_);
#line 124 "../src/Indicator.vala"
		g_object_ref_sink (_tmp17_);
#line 124 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->shutdown);
#line 124 "../src/Indicator.vala"
		self->priv->shutdown = _tmp17_;
#line 129 "../src/Indicator.vala"
		_tmp18_ = g_strdup (_ ("Suspend"));
#line 129 "../src/Indicator.vala"
		_tmp19_ = (GtkModelButton*) gtk_model_button_new ();
#line 129 "../src/Indicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
#line 129 "../src/Indicator.vala"
		g_object_set (_tmp19_, "text", _tmp18_, NULL);
#line 129 "../src/Indicator.vala"
		_g_free0 (_tmp18_);
#line 129 "../src/Indicator.vala"
		g_object_ref_sink (_tmp19_);
#line 129 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->suspend);
#line 129 "../src/Indicator.vala"
		self->priv->suspend = _tmp19_;
#line 134 "../src/Indicator.vala"
		if (self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 1262 "Indicator.c"
			GtkSeparator* users_separator = NULL;
			GtkSeparator* _tmp20_ = NULL;
			GtkSeparator* logout_separator = NULL;
			GtkSeparator* _tmp21_ = NULL;
			GtkScrolledWindow* scrolled_box = NULL;
			GtkScrolledWindow* _tmp22_ = NULL;
			GtkScrolledWindow* _tmp23_;
			SessionServicesUserManager* _tmp24_;
			SessionWidgetsUserListBox* _tmp25_;
			SessionWidgetsUserListBox* _tmp26_;
			GtkBox* _tmp27_;
			GtkScrolledWindow* _tmp28_;
			GtkBox* _tmp29_;
			GtkModelButton* _tmp30_;
			GtkBox* _tmp31_;
			GtkSeparator* _tmp32_;
			GtkBox* _tmp33_;
			GtkModelButton* _tmp34_;
			GtkBox* _tmp35_;
			GtkModelButton* _tmp36_;
			GtkBox* _tmp37_;
			GtkSeparator* _tmp38_;
#line 135 "../src/Indicator.vala"
			_tmp20_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 135 "../src/Indicator.vala"
			gtk_widget_set_margin_top ((GtkWidget*) _tmp20_, 3);
#line 135 "../src/Indicator.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp20_, 3);
#line 135 "../src/Indicator.vala"
			g_object_ref_sink (_tmp20_);
#line 135 "../src/Indicator.vala"
			users_separator = _tmp20_;
#line 140 "../src/Indicator.vala"
			_tmp21_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 140 "../src/Indicator.vala"
			gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 3);
#line 140 "../src/Indicator.vala"
			gtk_widget_set_margin_bottom ((GtkWidget*) _tmp21_, 3);
#line 140 "../src/Indicator.vala"
			g_object_ref_sink (_tmp21_);
#line 140 "../src/Indicator.vala"
			logout_separator = _tmp21_;
#line 145 "../src/Indicator.vala"
			_tmp22_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 145 "../src/Indicator.vala"
			gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, TRUE);
#line 145 "../src/Indicator.vala"
			g_object_set (_tmp22_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 145 "../src/Indicator.vala"
			gtk_scrolled_window_set_max_content_height (_tmp22_, 300);
#line 145 "../src/Indicator.vala"
			gtk_scrolled_window_set_propagate_natural_height (_tmp22_, TRUE);
#line 145 "../src/Indicator.vala"
			g_object_ref_sink (_tmp22_);
#line 145 "../src/Indicator.vala"
			scrolled_box = _tmp22_;
#line 151 "../src/Indicator.vala"
			_tmp23_ = scrolled_box;
#line 151 "../src/Indicator.vala"
			_tmp24_ = self->priv->manager;
#line 151 "../src/Indicator.vala"
			_tmp25_ = session_services_user_manager_get_user_grid (_tmp24_);
#line 151 "../src/Indicator.vala"
			_tmp26_ = _tmp25_;
#line 151 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp26_);
#line 153 "../src/Indicator.vala"
			_tmp27_ = self->priv->main_box;
#line 153 "../src/Indicator.vala"
			_tmp28_ = scrolled_box;
#line 153 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 154 "../src/Indicator.vala"
			_tmp29_ = self->priv->main_box;
#line 154 "../src/Indicator.vala"
			_tmp30_ = user_settings;
#line 154 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 155 "../src/Indicator.vala"
			_tmp31_ = self->priv->main_box;
#line 155 "../src/Indicator.vala"
			_tmp32_ = users_separator;
#line 155 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
#line 156 "../src/Indicator.vala"
			_tmp33_ = self->priv->main_box;
#line 156 "../src/Indicator.vala"
			_tmp34_ = self->priv->lock_screen;
#line 156 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 157 "../src/Indicator.vala"
			_tmp35_ = self->priv->main_box;
#line 157 "../src/Indicator.vala"
			_tmp36_ = self->priv->log_out;
#line 157 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
#line 158 "../src/Indicator.vala"
			_tmp37_ = self->priv->main_box;
#line 158 "../src/Indicator.vala"
			_tmp38_ = logout_separator;
#line 158 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 134 "../src/Indicator.vala"
			_g_object_unref0 (scrolled_box);
#line 134 "../src/Indicator.vala"
			_g_object_unref0 (logout_separator);
#line 134 "../src/Indicator.vala"
			_g_object_unref0 (users_separator);
#line 1371 "Indicator.c"
		}
#line 161 "../src/Indicator.vala"
		_tmp39_ = self->priv->main_box;
#line 161 "../src/Indicator.vala"
		_tmp40_ = self->priv->suspend;
#line 161 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 162 "../src/Indicator.vala"
		_tmp41_ = self->priv->main_box;
#line 162 "../src/Indicator.vala"
		_tmp42_ = self->priv->shutdown;
#line 162 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp42_);
#line 164 "../src/Indicator.vala"
		_tmp43_ = session_indicator_keybinding_settings;
#line 164 "../src/Indicator.vala"
		if (_tmp43_ != NULL) {
#line 1389 "Indicator.c"
			const GVariantType* key_type = NULL;
			GSettings* _tmp44_;
			GVariant* _tmp45_;
			GVariant* _tmp46_;
			const GVariantType* _tmp47_;
			const GVariantType* _tmp48_;
			const GVariantType* _tmp49_;
			const GVariantType* _tmp50_;
#line 166 "../src/Indicator.vala"
			_tmp44_ = session_indicator_keybinding_settings;
#line 166 "../src/Indicator.vala"
			_tmp45_ = g_settings_get_value (_tmp44_, "logout");
#line 166 "../src/Indicator.vala"
			_tmp46_ = _tmp45_;
#line 166 "../src/Indicator.vala"
			_tmp47_ = g_variant_get_type (_tmp46_);
#line 166 "../src/Indicator.vala"
			_tmp48_ = _tmp47_;
#line 166 "../src/Indicator.vala"
			_g_variant_unref0 (_tmp46_);
#line 166 "../src/Indicator.vala"
			key_type = _tmp48_;
#line 167 "../src/Indicator.vala"
			_tmp49_ = key_type;
#line 167 "../src/Indicator.vala"
			_tmp50_ = G_VARIANT_TYPE_STRING;
#line 167 "../src/Indicator.vala"
			if (g_variant_type_equal (_tmp49_, _tmp50_)) {
#line 1418 "Indicator.c"
				GraniteAccelLabel* _tmp51_;
				GSettings* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				GraniteAccelLabel* _tmp55_;
				GSettings* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				GSettings* _tmp59_;
				GSettings* _tmp60_;
#line 168 "../src/Indicator.vala"
				_tmp51_ = _data1_->log_out_grid;
#line 168 "../src/Indicator.vala"
				_tmp52_ = session_indicator_keybinding_settings;
#line 168 "../src/Indicator.vala"
				_tmp53_ = g_settings_get_string (_tmp52_, "logout");
#line 168 "../src/Indicator.vala"
				_tmp54_ = _tmp53_;
#line 168 "../src/Indicator.vala"
				granite_accel_label_set_accel_string (_tmp51_, _tmp54_);
#line 168 "../src/Indicator.vala"
				_g_free0 (_tmp54_);
#line 169 "../src/Indicator.vala"
				_tmp55_ = _data1_->lock_screen_grid;
#line 169 "../src/Indicator.vala"
				_tmp56_ = session_indicator_keybinding_settings;
#line 169 "../src/Indicator.vala"
				_tmp57_ = g_settings_get_string (_tmp56_, "screensaver");
#line 169 "../src/Indicator.vala"
				_tmp58_ = _tmp57_;
#line 169 "../src/Indicator.vala"
				granite_accel_label_set_accel_string (_tmp55_, _tmp58_);
#line 169 "../src/Indicator.vala"
				_g_free0 (_tmp58_);
#line 171 "../src/Indicator.vala"
				_tmp59_ = session_indicator_keybinding_settings;
#line 171 "../src/Indicator.vala"
				g_signal_connect_data (_tmp59_, "changed::logout", (GCallback) ______lambda27__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 175 "../src/Indicator.vala"
				_tmp60_ = session_indicator_keybinding_settings;
#line 175 "../src/Indicator.vala"
				g_signal_connect_data (_tmp60_, "changed::screensaver", (GCallback) ______lambda28__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 1461 "Indicator.c"
			} else {
				const GVariantType* _tmp61_;
				const GVariantType* _tmp62_;
#line 178 "../src/Indicator.vala"
				_tmp61_ = key_type;
#line 178 "../src/Indicator.vala"
				_tmp62_ = G_VARIANT_TYPE_STRING_ARRAY;
#line 178 "../src/Indicator.vala"
				if (g_variant_type_equal (_tmp61_, _tmp62_)) {
#line 1471 "Indicator.c"
					GraniteAccelLabel* _tmp63_;
					GSettings* _tmp64_;
					gchar** _tmp65_;
					gchar** _tmp66_;
					gchar** _tmp67_;
					gint _tmp67__length1;
					const gchar* _tmp68_;
					GraniteAccelLabel* _tmp69_;
					GSettings* _tmp70_;
					gchar** _tmp71_;
					gchar** _tmp72_;
					gchar** _tmp73_;
					gint _tmp73__length1;
					const gchar* _tmp74_;
					GSettings* _tmp75_;
					GSettings* _tmp76_;
#line 179 "../src/Indicator.vala"
					_tmp63_ = _data1_->log_out_grid;
#line 179 "../src/Indicator.vala"
					_tmp64_ = session_indicator_keybinding_settings;
#line 179 "../src/Indicator.vala"
					_tmp66_ = _tmp65_ = g_settings_get_strv (_tmp64_, "logout");
#line 179 "../src/Indicator.vala"
					_tmp67_ = _tmp66_;
#line 179 "../src/Indicator.vala"
					_tmp67__length1 = _vala_array_length (_tmp65_);
#line 179 "../src/Indicator.vala"
					_tmp68_ = _tmp67_[0];
#line 179 "../src/Indicator.vala"
					granite_accel_label_set_accel_string (_tmp63_, _tmp68_);
#line 179 "../src/Indicator.vala"
					_tmp67_ = (_vala_array_free (_tmp67_, _tmp67__length1, (GDestroyNotify) g_free), NULL);
#line 180 "../src/Indicator.vala"
					_tmp69_ = _data1_->lock_screen_grid;
#line 180 "../src/Indicator.vala"
					_tmp70_ = session_indicator_keybinding_settings;
#line 180 "../src/Indicator.vala"
					_tmp72_ = _tmp71_ = g_settings_get_strv (_tmp70_, "screensaver");
#line 180 "../src/Indicator.vala"
					_tmp73_ = _tmp72_;
#line 180 "../src/Indicator.vala"
					_tmp73__length1 = _vala_array_length (_tmp71_);
#line 180 "../src/Indicator.vala"
					_tmp74_ = _tmp73_[0];
#line 180 "../src/Indicator.vala"
					granite_accel_label_set_accel_string (_tmp69_, _tmp74_);
#line 180 "../src/Indicator.vala"
					_tmp73_ = (_vala_array_free (_tmp73_, _tmp73__length1, (GDestroyNotify) g_free), NULL);
#line 182 "../src/Indicator.vala"
					_tmp75_ = session_indicator_keybinding_settings;
#line 182 "../src/Indicator.vala"
					g_signal_connect_data (_tmp75_, "changed::logout", (GCallback) _______lambda29__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 186 "../src/Indicator.vala"
					_tmp76_ = session_indicator_keybinding_settings;
#line 186 "../src/Indicator.vala"
					g_signal_connect_data (_tmp76_, "changed::screensaver", (GCallback) _______lambda30__g_settings_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 1528 "Indicator.c"
				}
			}
		}
#line 192 "../src/Indicator.vala"
		_tmp77_ = self->priv->manager;
#line 192 "../src/Indicator.vala"
		g_signal_connect_object (_tmp77_, "close", (GCallback) ____lambda31__session_services_user_manager_close, self, 0);
#line 194 "../src/Indicator.vala"
		_tmp78_ = user_settings;
#line 194 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp78_, "clicked", (GCallback) ____lambda32__gtk_button_clicked, self, 0);
#line 204 "../src/Indicator.vala"
		_tmp79_ = self->priv->shutdown;
#line 204 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp79_, "clicked", (GCallback) ____lambda33__gtk_button_clicked, self, 0);
#line 208 "../src/Indicator.vala"
		_tmp80_ = self->priv->suspend;
#line 208 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp80_, "clicked", (GCallback) ____lambda34__gtk_button_clicked, self, 0);
#line 218 "../src/Indicator.vala"
		_tmp81_ = self->priv->log_out;
#line 218 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp81_, "clicked", (GCallback) ____lambda35__gtk_button_clicked, self, 0);
#line 230 "../src/Indicator.vala"
		_tmp82_ = self->priv->lock_screen;
#line 230 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp82_, "clicked", (GCallback) ____lambda37__gtk_button_clicked, self, 0);
#line 97 "../src/Indicator.vala"
		_g_object_unref0 (user_settings);
#line 97 "../src/Indicator.vala"
		block1_data_unref (_data1_);
#line 97 "../src/Indicator.vala"
		_data1_ = NULL;
#line 1562 "Indicator.c"
	}
#line 241 "../src/Indicator.vala"
	_tmp83_ = self->priv->main_box;
#line 241 "../src/Indicator.vala"
	_tmp84_ = _g_object_ref0 ((GtkWidget*) _tmp83_);
#line 241 "../src/Indicator.vala"
	result = _tmp84_;
#line 241 "../src/Indicator.vala"
	return result;
#line 1572 "Indicator.c"
}

static void
___lambda26_ (SessionIndicator* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 250 "../src/Indicator.vala"
	g_return_if_fail (res != NULL);
#line 1583 "Indicator.c"
	{
		SessionInterface* _tmp0_;
#line 252 "../src/Indicator.vala"
		_tmp0_ = self->priv->session_interface;
#line 252 "../src/Indicator.vala"
		session_interface_reboot_finish (_tmp0_, res, &_inner_error0_);
#line 252 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1592 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
#line 251 "../src/Indicator.vala"
		e = _inner_error0_;
#line 251 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 254 "../src/Indicator.vala"
		_tmp1_ = e;
#line 254 "../src/Indicator.vala"
		if (!g_error_matches (_tmp1_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1609 "Indicator.c"
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 255 "../src/Indicator.vala"
			_tmp2_ = e;
#line 255 "../src/Indicator.vala"
			_tmp3_ = _tmp2_->message;
#line 255 "../src/Indicator.vala"
			g_critical ("Indicator.vala:255: Unable to open shutdown dialog: %s", _tmp3_);
#line 1618 "Indicator.c"
		}
#line 251 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 1622 "Indicator.c"
	}
	__finally0:
#line 251 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 251 "../src/Indicator.vala"
		return;
#line 1633 "Indicator.c"
	}
}

static void
____lambda26__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 250 "../src/Indicator.vala"
	___lambda26_ ((SessionIndicator*) self, source_object, res);
#line 250 "../src/Indicator.vala"
	g_object_unref (self);
#line 1646 "Indicator.c"
}

static void
session_indicator_show_shutdown_dialog (SessionIndicator* self)
{
#line 244 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 247 "../src/Indicator.vala"
	if (self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 1658 "Indicator.c"
		SessionInterface* _tmp0_;
#line 250 "../src/Indicator.vala"
		_tmp0_ = self->priv->session_interface;
#line 250 "../src/Indicator.vala"
		session_interface_reboot (_tmp0_, ____lambda26__gasync_ready_callback, g_object_ref (self));
#line 1664 "Indicator.c"
	} else {
#line 260 "../src/Indicator.vala"
		session_indicator_show_dialog (self, SESSION_WIDGETS_END_SESSION_DIALOG_TYPE_RESTART);
#line 1668 "Indicator.c"
	}
}

static void
session_indicator_init_interfaces_data_free (gpointer _data)
{
	SessionIndicatorInitInterfacesData* _data_;
	_data_ = _data;
#line 20 "../src/Indicator.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Indicator.vala"
	g_slice_free (SessionIndicatorInitInterfacesData, _data_);
#line 1681 "Indicator.c"
}

static void
session_indicator_init_interfaces (SessionIndicator* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	SessionIndicatorInitInterfacesData* _data_;
	SessionIndicator* _tmp0_;
#line 20 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Indicator.vala"
	_data_ = g_slice_new0 (SessionIndicatorInitInterfacesData);
#line 20 "../src/Indicator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Indicator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_indicator_init_interfaces_data_free);
#line 20 "../src/Indicator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Indicator.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Indicator.vala"
	session_indicator_init_interfaces_co (_data_);
#line 1705 "Indicator.c"
}

static void
session_indicator_init_interfaces_finish (SessionIndicator* self,
                                          GAsyncResult* _res_)
{
	SessionIndicatorInitInterfacesData* _data_;
#line 20 "../src/Indicator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1715 "Indicator.c"
}

static void
session_indicator_init_interfaces_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	SessionIndicatorInitInterfacesData* _data_;
#line 266 "../src/Indicator.vala"
	_data_ = _user_data_;
#line 266 "../src/Indicator.vala"
	_data_->_source_object_ = source_object;
#line 266 "../src/Indicator.vala"
	_data_->_res_ = _res_;
#line 266 "../src/Indicator.vala"
	session_indicator_init_interfaces_co (_data_);
#line 1732 "Indicator.c"
}

static gboolean
session_indicator_init_interfaces_co (SessionIndicatorInitInterfacesData* _data_)
{
#line 264 "../src/Indicator.vala"
	switch (_data_->_state_) {
#line 264 "../src/Indicator.vala"
		case 0:
#line 1742 "Indicator.c"
		goto _state_0;
#line 264 "../src/Indicator.vala"
		case 1:
#line 1746 "Indicator.c"
		goto _state_1;
#line 264 "../src/Indicator.vala"
		case 2:
#line 1750 "Indicator.c"
		goto _state_2;
#line 264 "../src/Indicator.vala"
		case 3:
#line 1754 "Indicator.c"
		goto _state_3;
		default:
#line 264 "../src/Indicator.vala"
		g_assert_not_reached ();
#line 1759 "Indicator.c"
	}
	_state_0:
	{
#line 266 "../src/Indicator.vala"
		_data_->_state_ = 1;
#line 266 "../src/Indicator.vala"
		g_async_initable_new_async (TYPE_SYSTEM_INTERFACE_PROXY, 0, NULL, session_indicator_init_interfaces_ready, _data_, "g-flags", 0, "g-name", "org.freedesktop.login1", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/org/freedesktop/login1", "g-interface-name", "org.freedesktop.login1.Manager", NULL);
#line 266 "../src/Indicator.vala"
		return FALSE;
#line 1769 "Indicator.c"
		_state_1:
#line 266 "../src/Indicator.vala"
		_data_->_tmp1_ = (SystemInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 266 "../src/Indicator.vala"
		_data_->_tmp0_ = (SystemInterface*) _data_->_tmp1_;
#line 266 "../src/Indicator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 266 "../src/Indicator.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 1779 "Indicator.c"
				goto __catch0_g_io_error;
			}
#line 266 "../src/Indicator.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 266 "../src/Indicator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 266 "../src/Indicator.vala"
			g_object_unref (_data_->_async_result);
#line 266 "../src/Indicator.vala"
			return FALSE;
#line 1790 "Indicator.c"
		}
#line 266 "../src/Indicator.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 266 "../src/Indicator.vala"
		_data_->_tmp0_ = NULL;
#line 266 "../src/Indicator.vala"
		_g_object_unref0 (_data_->self->priv->system_interface);
#line 266 "../src/Indicator.vala"
		_data_->self->priv->system_interface = _data_->_tmp2_;
#line 267 "../src/Indicator.vala"
		_data_->_tmp3_ = _data_->self->priv->suspend;
#line 267 "../src/Indicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp3_, TRUE);
#line 265 "../src/Indicator.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1806 "Indicator.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 265 "../src/Indicator.vala"
		_data_->e = _data_->_inner_error0_;
#line 265 "../src/Indicator.vala"
		_data_->_inner_error0_ = NULL;
#line 269 "../src/Indicator.vala"
		_data_->_tmp4_ = _data_->e;
#line 269 "../src/Indicator.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 269 "../src/Indicator.vala"
		g_critical ("Indicator.vala:269: Unable to connect to the login interface: %s", _data_->_tmp5_);
#line 270 "../src/Indicator.vala"
		_data_->_tmp6_ = _data_->self->priv->suspend;
#line 270 "../src/Indicator.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp6_, FALSE);
#line 265 "../src/Indicator.vala"
		_g_error_free0 (_data_->e);
#line 1827 "Indicator.c"
	}
	__finally0:
#line 265 "../src/Indicator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 265 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 265 "../src/Indicator.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 265 "../src/Indicator.vala"
		g_object_unref (_data_->_async_result);
#line 265 "../src/Indicator.vala"
		return FALSE;
#line 1840 "Indicator.c"
	}
#line 273 "../src/Indicator.vala"
	if (_data_->self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 1844 "Indicator.c"
		{
#line 275 "../src/Indicator.vala"
			_data_->_state_ = 2;
#line 275 "../src/Indicator.vala"
			g_async_initable_new_async (TYPE_LOCK_INTERFACE_PROXY, 0, NULL, session_indicator_init_interfaces_ready, _data_, "g-flags", 0, "g-name", "org.gnome.ScreenSaver", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/ScreenSaver", "g-interface-name", "org.gnome.ScreenSaver", NULL);
#line 275 "../src/Indicator.vala"
			return FALSE;
#line 1852 "Indicator.c"
			_state_2:
#line 275 "../src/Indicator.vala"
			_data_->_tmp8_ = (LockInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 275 "../src/Indicator.vala"
			_data_->_tmp7_ = (LockInterface*) _data_->_tmp8_;
#line 275 "../src/Indicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 275 "../src/Indicator.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 1862 "Indicator.c"
					goto __catch1_g_io_error;
				}
#line 275 "../src/Indicator.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 275 "../src/Indicator.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 275 "../src/Indicator.vala"
				g_object_unref (_data_->_async_result);
#line 275 "../src/Indicator.vala"
				return FALSE;
#line 1873 "Indicator.c"
			}
#line 275 "../src/Indicator.vala"
			_data_->_tmp9_ = _data_->_tmp7_;
#line 275 "../src/Indicator.vala"
			_data_->_tmp7_ = NULL;
#line 275 "../src/Indicator.vala"
			_g_object_unref0 (_data_->self->priv->lock_interface);
#line 275 "../src/Indicator.vala"
			_data_->self->priv->lock_interface = _data_->_tmp9_;
#line 276 "../src/Indicator.vala"
			_data_->_tmp10_ = _data_->self->priv->lock_screen;
#line 276 "../src/Indicator.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp10_, TRUE);
#line 274 "../src/Indicator.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 1889 "Indicator.c"
		}
		goto __finally1;
		__catch1_g_io_error:
		{
#line 274 "../src/Indicator.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 274 "../src/Indicator.vala"
			_data_->_inner_error0_ = NULL;
#line 278 "../src/Indicator.vala"
			_data_->_tmp11_ = _data_->_vala1_e;
#line 278 "../src/Indicator.vala"
			_data_->_tmp12_ = _data_->_tmp11_->message;
#line 278 "../src/Indicator.vala"
			g_warning ("Indicator.vala:278: Unable to connect to lock interface: %s", _data_->_tmp12_);
#line 274 "../src/Indicator.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 1906 "Indicator.c"
		}
		__finally1:
#line 274 "../src/Indicator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 274 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 274 "../src/Indicator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 274 "../src/Indicator.vala"
			g_object_unref (_data_->_async_result);
#line 274 "../src/Indicator.vala"
			return FALSE;
#line 1919 "Indicator.c"
		}
		{
#line 282 "../src/Indicator.vala"
			_data_->_state_ = 3;
#line 282 "../src/Indicator.vala"
			g_async_initable_new_async (TYPE_SESSION_INTERFACE_PROXY, 0, NULL, session_indicator_init_interfaces_ready, _data_, "g-flags", 0, "g-name", "org.gnome.SessionManager", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/SessionManager", "g-interface-name", "org.gnome.SessionManager", NULL);
#line 282 "../src/Indicator.vala"
			return FALSE;
#line 1928 "Indicator.c"
			_state_3:
#line 282 "../src/Indicator.vala"
			_data_->_tmp14_ = (SessionInterface*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 282 "../src/Indicator.vala"
			_data_->_tmp13_ = (SessionInterface*) _data_->_tmp14_;
#line 282 "../src/Indicator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 282 "../src/Indicator.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 1938 "Indicator.c"
					goto __catch2_g_io_error;
				}
#line 282 "../src/Indicator.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 282 "../src/Indicator.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 282 "../src/Indicator.vala"
				g_object_unref (_data_->_async_result);
#line 282 "../src/Indicator.vala"
				return FALSE;
#line 1949 "Indicator.c"
			}
#line 282 "../src/Indicator.vala"
			_data_->_tmp15_ = _data_->_tmp13_;
#line 282 "../src/Indicator.vala"
			_data_->_tmp13_ = NULL;
#line 282 "../src/Indicator.vala"
			_g_object_unref0 (_data_->self->priv->session_interface);
#line 282 "../src/Indicator.vala"
			_data_->self->priv->session_interface = _data_->_tmp15_;
#line 283 "../src/Indicator.vala"
			_data_->_tmp16_ = _data_->self->priv->shutdown;
#line 283 "../src/Indicator.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp16_, TRUE);
#line 284 "../src/Indicator.vala"
			_data_->_tmp17_ = _data_->self->priv->log_out;
#line 284 "../src/Indicator.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _data_->_tmp17_, TRUE);
#line 281 "../src/Indicator.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 1969 "Indicator.c"
		}
		goto __finally2;
		__catch2_g_io_error:
		{
#line 281 "../src/Indicator.vala"
			_data_->_vala2_e = _data_->_inner_error0_;
#line 281 "../src/Indicator.vala"
			_data_->_inner_error0_ = NULL;
#line 286 "../src/Indicator.vala"
			_data_->_tmp18_ = _data_->_vala2_e;
#line 286 "../src/Indicator.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 286 "../src/Indicator.vala"
			g_critical ("Indicator.vala:286: Unable to connect to GNOME session interface: %s", _data_->_tmp19_);
#line 281 "../src/Indicator.vala"
			_g_error_free0 (_data_->_vala2_e);
#line 1986 "Indicator.c"
		}
		__finally2:
#line 281 "../src/Indicator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 281 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 281 "../src/Indicator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 281 "../src/Indicator.vala"
			g_object_unref (_data_->_async_result);
#line 281 "../src/Indicator.vala"
			return FALSE;
#line 1999 "Indicator.c"
		}
	}
#line 264 "../src/Indicator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 264 "../src/Indicator.vala"
	if (_data_->_state_ != 0) {
#line 264 "../src/Indicator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 264 "../src/Indicator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2010 "Indicator.c"
		}
	}
#line 264 "../src/Indicator.vala"
	g_object_unref (_data_->_async_result);
#line 264 "../src/Indicator.vala"
	return FALSE;
#line 2017 "Indicator.c"
}

static void
session_indicator_real_opened (WingpanelIndicator* base)
{
	SessionIndicator * self;
	GtkBox* _tmp1_;
#line 291 "../src/Indicator.vala"
	self = (SessionIndicator*) base;
#line 292 "../src/Indicator.vala"
	if (self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 2029 "Indicator.c"
		SessionServicesUserManager* _tmp0_;
#line 293 "../src/Indicator.vala"
		_tmp0_ = self->priv->manager;
#line 293 "../src/Indicator.vala"
		session_services_user_manager_update_all (_tmp0_);
#line 2035 "Indicator.c"
	}
#line 296 "../src/Indicator.vala"
	_tmp1_ = self->priv->main_box;
#line 296 "../src/Indicator.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 2041 "Indicator.c"
}

static void
session_indicator_real_closed (WingpanelIndicator* base)
{
	SessionIndicator * self;
#line 299 "../src/Indicator.vala"
	self = (SessionIndicator*) base;
#line 2050 "Indicator.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 301 "../src/Indicator.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 301 "../src/Indicator.vala"
	return _data2_;
#line 2060 "Indicator.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 301 "../src/Indicator.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2070 "Indicator.c"
		SessionIndicator* self;
#line 301 "../src/Indicator.vala"
		self = _data2_->self;
#line 301 "../src/Indicator.vala"
		_g_object_unref0 (self);
#line 301 "../src/Indicator.vala"
		g_slice_free (Block2Data, _data2_);
#line 2078 "Indicator.c"
	}
}

static void
__lambda18_ (Block2Data* _data2_)
{
	SessionIndicator* self;
	SessionEndSessionDialogServer* _tmp0_;
#line 317 "../src/Indicator.vala"
	self = _data2_->self;
#line 318 "../src/Indicator.vala"
	_tmp0_ = _data2_->server;
#line 318 "../src/Indicator.vala"
	g_signal_emit_by_name (_tmp0_, "closed");
#line 319 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->current_dialog);
#line 319 "../src/Indicator.vala"
	self->priv->current_dialog = NULL;
#line 2097 "Indicator.c"
}

static void
___lambda18__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
#line 317 "../src/Indicator.vala"
	__lambda18_ (self);
#line 2106 "Indicator.c"
}

static void
__lambda19_ (Block2Data* _data2_)
{
	SessionIndicator* self;
	SessionEndSessionDialogServer* _tmp0_;
#line 322 "../src/Indicator.vala"
	self = _data2_->self;
#line 323 "../src/Indicator.vala"
	_tmp0_ = _data2_->server;
#line 323 "../src/Indicator.vala"
	g_signal_emit_by_name (_tmp0_, "canceled");
#line 2120 "Indicator.c"
}

static void
___lambda19__session_widgets_end_session_dialog_cancelled (SessionWidgetsEndSessionDialog* _sender,
                                                           gpointer self)
{
#line 322 "../src/Indicator.vala"
	__lambda19_ (self);
#line 2129 "Indicator.c"
}

static void
__lambda20_ (Block2Data* _data2_)
{
	SessionIndicator* self;
	SessionEndSessionDialogServer* _tmp0_;
#line 326 "../src/Indicator.vala"
	self = _data2_->self;
#line 327 "../src/Indicator.vala"
	_tmp0_ = _data2_->server;
#line 327 "../src/Indicator.vala"
	g_signal_emit_by_name (_tmp0_, "confirmed-logout");
#line 2143 "Indicator.c"
}

static void
___lambda20__session_widgets_end_session_dialog_logout (SessionWidgetsEndSessionDialog* _sender,
                                                        gpointer self)
{
#line 326 "../src/Indicator.vala"
	__lambda20_ (self);
#line 2152 "Indicator.c"
}

static void
__lambda21_ (Block2Data* _data2_)
{
	SessionIndicator* self;
	GError* _inner_error0_ = NULL;
#line 330 "../src/Indicator.vala"
	self = _data2_->self;
#line 331 "../src/Indicator.vala"
	if (self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 2164 "Indicator.c"
		SessionEndSessionDialogServer* _tmp0_;
#line 332 "../src/Indicator.vala"
		_tmp0_ = _data2_->server;
#line 332 "../src/Indicator.vala"
		g_signal_emit_by_name (_tmp0_, "confirmed-shutdown");
#line 2170 "Indicator.c"
	} else {
		{
			SystemInterface* _tmp1_;
#line 335 "../src/Indicator.vala"
			_tmp1_ = self->priv->system_interface;
#line 335 "../src/Indicator.vala"
			system_interface_power_off (_tmp1_, FALSE, &_inner_error0_);
#line 335 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2180 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 334 "../src/Indicator.vala"
			e = _inner_error0_;
#line 334 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 337 "../src/Indicator.vala"
			_tmp2_ = e;
#line 337 "../src/Indicator.vala"
			_tmp3_ = _tmp2_->message;
#line 337 "../src/Indicator.vala"
			g_warning ("Indicator.vala:337: Unable to shutdown: %s", _tmp3_);
#line 334 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 2202 "Indicator.c"
		}
		__finally0:
#line 334 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 334 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 334 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 334 "../src/Indicator.vala"
			return;
#line 2213 "Indicator.c"
		}
	}
}

static void
___lambda21__session_widgets_end_session_dialog_shutdown (SessionWidgetsEndSessionDialog* _sender,
                                                          gpointer self)
{
#line 330 "../src/Indicator.vala"
	__lambda21_ (self);
#line 2224 "Indicator.c"
}

static void
__lambda22_ (Block2Data* _data2_)
{
	SessionIndicator* self;
	GError* _inner_error0_ = NULL;
#line 342 "../src/Indicator.vala"
	self = _data2_->self;
#line 343 "../src/Indicator.vala"
	if (self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 2236 "Indicator.c"
		SessionEndSessionDialogServer* _tmp0_;
#line 344 "../src/Indicator.vala"
		_tmp0_ = _data2_->server;
#line 344 "../src/Indicator.vala"
		g_signal_emit_by_name (_tmp0_, "confirmed-reboot");
#line 2242 "Indicator.c"
	} else {
		{
			SystemInterface* _tmp1_;
#line 347 "../src/Indicator.vala"
			_tmp1_ = self->priv->system_interface;
#line 347 "../src/Indicator.vala"
			system_interface_reboot (_tmp1_, FALSE, &_inner_error0_);
#line 347 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2252 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 346 "../src/Indicator.vala"
			e = _inner_error0_;
#line 346 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 349 "../src/Indicator.vala"
			_tmp2_ = e;
#line 349 "../src/Indicator.vala"
			_tmp3_ = _tmp2_->message;
#line 349 "../src/Indicator.vala"
			g_warning ("Indicator.vala:349: Unable to reboot: %s", _tmp3_);
#line 346 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 2274 "Indicator.c"
		}
		__finally0:
#line 346 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 346 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 346 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 346 "../src/Indicator.vala"
			return;
#line 2285 "Indicator.c"
		}
	}
}

static void
___lambda22__session_widgets_end_session_dialog_reboot (SessionWidgetsEndSessionDialog* _sender,
                                                        gpointer self)
{
#line 342 "../src/Indicator.vala"
	__lambda22_ (self);
#line 2296 "Indicator.c"
}

static void
session_indicator_show_dialog (SessionIndicator* self,
                               SessionWidgetsEndSessionDialogType type)
{
	Block2Data* _data2_;
	SessionWidgetsEndSessionDialog* _tmp0_;
	SessionEndSessionDialogServer* _tmp5_;
	GtkImage* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWindow* _tmp8_;
	SessionWidgetsEndSessionDialog* _tmp9_ = NULL;
	SessionWidgetsEndSessionDialog* _tmp10_;
	SessionWidgetsEndSessionDialog* _tmp11_;
	SessionWidgetsEndSessionDialog* _tmp12_;
	SessionWidgetsEndSessionDialog* _tmp13_;
	SessionWidgetsEndSessionDialog* _tmp14_;
	SessionWidgetsEndSessionDialog* _tmp15_;
#line 301 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Indicator.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 301 "../src/Indicator.vala"
	_data2_->_ref_count_ = 1;
#line 301 "../src/Indicator.vala"
	_data2_->self = g_object_ref (self);
#line 302 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 304 "../src/Indicator.vala"
	_tmp0_ = self->priv->current_dialog;
#line 304 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 2330 "Indicator.c"
		SessionWidgetsEndSessionDialog* _tmp1_;
		SessionWidgetsEndSessionDialogType _tmp2_;
		SessionWidgetsEndSessionDialogType _tmp3_;
#line 305 "../src/Indicator.vala"
		_tmp1_ = self->priv->current_dialog;
#line 305 "../src/Indicator.vala"
		_tmp2_ = session_widgets_end_session_dialog_get_dialog_type (_tmp1_);
#line 305 "../src/Indicator.vala"
		_tmp3_ = _tmp2_;
#line 305 "../src/Indicator.vala"
		if (_tmp3_ != type) {
#line 2342 "Indicator.c"
			SessionWidgetsEndSessionDialog* _tmp4_;
#line 306 "../src/Indicator.vala"
			_tmp4_ = self->priv->current_dialog;
#line 306 "../src/Indicator.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 2348 "Indicator.c"
		} else {
#line 308 "../src/Indicator.vala"
			block2_data_unref (_data2_);
#line 308 "../src/Indicator.vala"
			_data2_ = NULL;
#line 308 "../src/Indicator.vala"
			return;
#line 2356 "Indicator.c"
		}
	}
#line 312 "../src/Indicator.vala"
	_tmp5_ = session_end_session_dialog_server_get_default ();
#line 312 "../src/Indicator.vala"
	_data2_->server = _tmp5_;
#line 314 "../src/Indicator.vala"
	_tmp6_ = self->priv->indicator_icon;
#line 314 "../src/Indicator.vala"
	_tmp7_ = gtk_widget_get_toplevel ((GtkWidget*) _tmp6_);
#line 314 "../src/Indicator.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_window_get_type (), GtkWindow));
#line 314 "../src/Indicator.vala"
	_tmp9_ = session_widgets_end_session_dialog_new (type);
#line 314 "../src/Indicator.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp9_, _tmp8_);
#line 314 "../src/Indicator.vala"
	_g_object_unref0 (_tmp8_);
#line 314 "../src/Indicator.vala"
	g_object_ref_sink (_tmp9_);
#line 314 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->current_dialog);
#line 314 "../src/Indicator.vala"
	self->priv->current_dialog = _tmp9_;
#line 317 "../src/Indicator.vala"
	_tmp10_ = self->priv->current_dialog;
#line 317 "../src/Indicator.vala"
	g_signal_connect_data ((GtkWidget*) _tmp10_, "destroy", (GCallback) ___lambda18__gtk_widget_destroy, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 322 "../src/Indicator.vala"
	_tmp11_ = self->priv->current_dialog;
#line 322 "../src/Indicator.vala"
	g_signal_connect_data (_tmp11_, "cancelled", (GCallback) ___lambda19__session_widgets_end_session_dialog_cancelled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 326 "../src/Indicator.vala"
	_tmp12_ = self->priv->current_dialog;
#line 326 "../src/Indicator.vala"
	g_signal_connect_data (_tmp12_, "logout", (GCallback) ___lambda20__session_widgets_end_session_dialog_logout, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 330 "../src/Indicator.vala"
	_tmp13_ = self->priv->current_dialog;
#line 330 "../src/Indicator.vala"
	g_signal_connect_data (_tmp13_, "shutdown", (GCallback) ___lambda21__session_widgets_end_session_dialog_shutdown, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 342 "../src/Indicator.vala"
	_tmp14_ = self->priv->current_dialog;
#line 342 "../src/Indicator.vala"
	g_signal_connect_data (_tmp14_, "reboot", (GCallback) ___lambda22__session_widgets_end_session_dialog_reboot, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 354 "../src/Indicator.vala"
	_tmp15_ = self->priv->current_dialog;
#line 354 "../src/Indicator.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 301 "../src/Indicator.vala"
	block2_data_unref (_data2_);
#line 301 "../src/Indicator.vala"
	_data2_ = NULL;
#line 2409 "Indicator.c"
}

static void
session_indicator_update_tooltip_data_free (gpointer _data)
{
	SessionIndicatorUpdateTooltipData* _data_;
	_data_ = _data;
#line 20 "../src/Indicator.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Indicator.vala"
	g_slice_free (SessionIndicatorUpdateTooltipData, _data_);
#line 2421 "Indicator.c"
}

static void
session_indicator_update_tooltip (SessionIndicator* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SessionIndicatorUpdateTooltipData* _data_;
	SessionIndicator* _tmp0_;
#line 20 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Indicator.vala"
	_data_ = g_slice_new0 (SessionIndicatorUpdateTooltipData);
#line 20 "../src/Indicator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Indicator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, session_indicator_update_tooltip_data_free);
#line 20 "../src/Indicator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Indicator.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Indicator.vala"
	session_indicator_update_tooltip_co (_data_);
#line 2445 "Indicator.c"
}

static void
session_indicator_update_tooltip_finish (SessionIndicator* self,
                                         GAsyncResult* _res_)
{
	SessionIndicatorUpdateTooltipData* _data_;
#line 20 "../src/Indicator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2455 "Indicator.c"
}

static void
session_indicator_update_tooltip_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	SessionIndicatorUpdateTooltipData* _data_;
#line 365 "../src/Indicator.vala"
	_data_ = _user_data_;
#line 365 "../src/Indicator.vala"
	_data_->_source_object_ = source_object;
#line 365 "../src/Indicator.vala"
	_data_->_res_ = _res_;
#line 365 "../src/Indicator.vala"
	session_indicator_update_tooltip_co (_data_);
#line 2472 "Indicator.c"
}

static gboolean
session_indicator_update_tooltip_co (SessionIndicatorUpdateTooltipData* _data_)
{
#line 357 "../src/Indicator.vala"
	switch (_data_->_state_) {
#line 357 "../src/Indicator.vala"
		case 0:
#line 2482 "Indicator.c"
		goto _state_0;
#line 357 "../src/Indicator.vala"
		case 1:
#line 2486 "Indicator.c"
		goto _state_1;
		default:
#line 357 "../src/Indicator.vala"
		g_assert_not_reached ();
#line 2491 "Indicator.c"
	}
	_state_0:
#line 360 "../src/Indicator.vala"
	if (_data_->self->priv->server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION) {
#line 361 "../src/Indicator.vala"
		_data_->_tmp0_ = _data_->self->priv->active_user_real_name;
#line 361 "../src/Indicator.vala"
		if (_data_->_tmp0_ == NULL) {
#line 362 "../src/Indicator.vala"
			_data_->_tmp1_ = g_get_real_name ();
#line 362 "../src/Indicator.vala"
			_data_->_tmp2_ = g_strdup (_data_->_tmp1_);
#line 362 "../src/Indicator.vala"
			_g_free0 (_data_->self->priv->active_user_real_name);
#line 362 "../src/Indicator.vala"
			_data_->self->priv->active_user_real_name = _data_->_tmp2_;
#line 2508 "Indicator.c"
		}
#line 365 "../src/Indicator.vala"
		_data_->_tmp3_ = _data_->self->priv->manager;
#line 365 "../src/Indicator.vala"
		_data_->_state_ = 1;
#line 365 "../src/Indicator.vala"
		session_services_user_manager_get_n_active_and_online_users (_data_->_tmp3_, session_indicator_update_tooltip_ready, _data_);
#line 365 "../src/Indicator.vala"
		return FALSE;
#line 2518 "Indicator.c"
		_state_1:
#line 365 "../src/Indicator.vala"
		_data_->n_online_users = session_services_user_manager_get_n_active_and_online_users_finish (_data_->_tmp3_, _data_->_res_) - 1;
#line 367 "../src/Indicator.vala"
		if (_data_->n_online_users > 0) {
#line 368 "../src/Indicator.vala"
			_data_->_tmp4_ = g_strdup (g_dngettext (SESSION_GETTEXT_PACKAGE, "Logged in as “%s”, %i other user logged in", "Logged in as “%s”, %i other users logged in", (gulong) _data_->n_online_users));
#line 368 "../src/Indicator.vala"
			_g_free0 (_data_->description);
#line 368 "../src/Indicator.vala"
			_data_->description = _data_->_tmp4_;
#line 374 "../src/Indicator.vala"
			_data_->_tmp5_ = _data_->description;
#line 374 "../src/Indicator.vala"
			_data_->_tmp6_ = _data_->self->priv->active_user_real_name;
#line 374 "../src/Indicator.vala"
			_data_->_tmp7_ = g_strdup_printf (_data_->_tmp5_, _data_->_tmp6_, _data_->n_online_users);
#line 374 "../src/Indicator.vala"
			_g_free0 (_data_->description);
#line 374 "../src/Indicator.vala"
			_data_->description = _data_->_tmp7_;
#line 2540 "Indicator.c"
		} else {
#line 376 "../src/Indicator.vala"
			_data_->_tmp8_ = _data_->self->priv->active_user_real_name;
#line 376 "../src/Indicator.vala"
			_data_->_tmp9_ = g_strdup_printf (_ ("Logged in as “%s”"), _data_->_tmp8_);
#line 376 "../src/Indicator.vala"
			_g_free0 (_data_->description);
#line 376 "../src/Indicator.vala"
			_data_->description = _data_->_tmp9_;
#line 2550 "Indicator.c"
		}
	} else {
#line 379 "../src/Indicator.vala"
		_data_->_tmp10_ = g_strdup (_ ("Not logged in"));
#line 379 "../src/Indicator.vala"
		_g_free0 (_data_->description);
#line 379 "../src/Indicator.vala"
		_data_->description = _data_->_tmp10_;
#line 2559 "Indicator.c"
	}
#line 382 "../src/Indicator.vala"
	_data_->_tmp11_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _ ("Middle-click to prompt to shut down"));
#line 382 "../src/Indicator.vala"
	_data_->accel_label = _data_->_tmp11_;
#line 384 "../src/Indicator.vala"
	_data_->_tmp12_ = _data_->self->priv->indicator_icon;
#line 384 "../src/Indicator.vala"
	_data_->_tmp13_ = _data_->description;
#line 384 "../src/Indicator.vala"
	_data_->_tmp14_ = g_strdup_printf ("%s\n%s", _data_->_tmp13_, _data_->accel_label);
#line 384 "../src/Indicator.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 384 "../src/Indicator.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _data_->_tmp12_, _data_->_tmp15_);
#line 384 "../src/Indicator.vala"
	_g_free0 (_data_->_tmp15_);
#line 357 "../src/Indicator.vala"
	_g_free0 (_data_->accel_label);
#line 357 "../src/Indicator.vala"
	_g_free0 (_data_->description);
#line 357 "../src/Indicator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 357 "../src/Indicator.vala"
	if (_data_->_state_ != 0) {
#line 357 "../src/Indicator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 357 "../src/Indicator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2589 "Indicator.c"
		}
	}
#line 357 "../src/Indicator.vala"
	g_object_unref (_data_->_async_result);
#line 357 "../src/Indicator.vala"
	return FALSE;
#line 2596 "Indicator.c"
}

static void
session_indicator_class_init (SessionIndicatorClass * klass,
                              gpointer klass_data)
{
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	gboolean _tmp3_;
#line 20 "../src/Indicator.vala"
	session_indicator_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &SessionIndicator_private_offset);
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) session_indicator_real_get_display_widget;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) session_indicator_real_get_widget;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) session_indicator_real_opened;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) session_indicator_real_closed;
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = session_indicator_finalize;
#line 59 "../src/Indicator.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 59 "../src/Indicator.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, SESSION_INDICATOR_KEYBINDING_SCHEMA, TRUE);
#line 59 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/Indicator.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 59 "../src/Indicator.vala"
	_g_settings_schema_unref0 (_tmp2_);
#line 59 "../src/Indicator.vala"
	if (_tmp3_) {
#line 2633 "Indicator.c"
		GSettings* _tmp4_;
#line 60 "../src/Indicator.vala"
		_tmp4_ = g_settings_new (SESSION_INDICATOR_KEYBINDING_SCHEMA);
#line 60 "../src/Indicator.vala"
		_g_object_unref0 (session_indicator_keybinding_settings);
#line 60 "../src/Indicator.vala"
		session_indicator_keybinding_settings = _tmp4_;
#line 2641 "Indicator.c"
	}
}

static void
session_indicator_instance_init (SessionIndicator * self,
                                 gpointer klass)
{
#line 20 "../src/Indicator.vala"
	self->priv = session_indicator_get_instance_private (self);
#line 37 "../src/Indicator.vala"
	self->priv->current_dialog = NULL;
#line 2653 "Indicator.c"
}

static void
session_indicator_finalize (GObject * obj)
{
	SessionIndicator * self;
#line 20 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SESSION_TYPE_INDICATOR, SessionIndicator);
#line 24 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->lock_interface);
#line 25 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->session_interface);
#line 26 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->system_interface);
#line 29 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->indicator_icon);
#line 31 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->lock_screen);
#line 32 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->suspend);
#line 33 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->shutdown);
#line 34 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->log_out);
#line 36 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->manager);
#line 37 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->current_dialog);
#line 39 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->main_box);
#line 40 "../src/Indicator.vala"
	_g_free0 (self->priv->active_user_real_name);
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (session_indicator_parent_class)->finalize (obj);
#line 2688 "Indicator.c"
}

static GType
session_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SessionIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) session_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SessionIndicator), 0, (GInstanceInitFunc) session_indicator_instance_init, NULL };
	GType session_indicator_type_id;
	session_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "SessionIndicator", &g_define_type_info, 0);
	SessionIndicator_private_offset = g_type_add_instance_private (session_indicator_type_id, sizeof (SessionIndicatorPrivate));
	return session_indicator_type_id;
}

GType
session_indicator_get_type (void)
{
	static volatile gsize session_indicator_type_id__once = 0;
	if (g_once_init_enter (&session_indicator_type_id__once)) {
		GType session_indicator_type_id;
		session_indicator_type_id = session_indicator_get_type_once ();
		g_once_init_leave (&session_indicator_type_id__once, session_indicator_type_id);
	}
	return session_indicator_type_id__once;
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	SessionIndicator* indicator = NULL;
	SessionIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 391 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 392 "../src/Indicator.vala"
	g_debug ("Indicator.vala:392: Activating Session Indicator");
#line 393 "../src/Indicator.vala"
	_tmp0_ = session_indicator_new (server_type);
#line 393 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 395 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 395 "../src/Indicator.vala"
	return result;
#line 2732 "Indicator.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

